# NSIT Connect

[![Build Status](https://travis-ci.org/Swati4star/NSIT-App-v2.svg?branch=master)](https://travis-ci.org/Swati4star/NSIT-App-v2) [![Circle CI](https://circleci.com/gh/Swati4star/NSIT-App-v2.svg?style=svg)](https://circleci.com/gh/Swati4star/NSIT-App-v2)

### Download from Google Play
<a href="https://play.google.com/store/apps/details?id=nsit.app.com.nsitapp"><img alt="Get it on Google Play" src="https://play.google.com/intl/en_us/badges/images/generic/en-play-badge.png" height=50px/></a>  


NSIT Connect is the official NSITOnline app that aims to act as a companion app for the students of NSIT. The app contains several useful modules that enable students to stay up-to-date with all the college news, maintain a schedule according to their timetable, find out all about interesting places in and around college, and more.

But this project is a lot more than an app. This is an initiative that is targetted at all the emerging developers of NSIT and encourages them to take part in this as a collaborative open-source team effort. So if you are an NSITian and you love developing things and wish to see them used by a large number of people, you have come to the right place. 

+ **[Play Store App Link](https://play.google.com/store/apps/details?id=nsit.app.com.nsitapp)**
+ **[NSITonline](http://www.nsitonline.in)**
+ **[Features](#features)**
  + [NSITOnline News Feed](#1nsitonline-news-feed)
  + [My Feed](#2my-feed)
  + [Video](#3video)
  + [Calendar](#4calendar)
  + [Locations](#5locations)
  + [CodeRadar](#6coderadar)
  + [Calculator](#7calculator)
+ **[APIs Used](https://github.com/Swati4star/NSIT-App-v2/wiki#apis-used)**
+ **[Dependencies](https://github.com/Swati4star/NSIT-App-v2/wiki#dependencies)**
+ **[Building](#building)**
+ **[Other repositories](#other-repositories)**
  + [Windows](https://github.com/sgaggarwal2009/NSIT-Connect-Microsoft-App)
  + [iOS](https://github.com/Swapnil52/NSIT-Connect)
+ **[Contribution](#contribution)**
+ **[Project Maintainers](#project-maintainers)**
+ **[Wiki Page](https://github.com/Swati4star/NSIT-App-v2/wiki)**


## Features
###1.NSITOnline News Feed
The home page is the news feed of the NSITOnline official page. All the latest news are pulled and shown in an aesthetic UI. You can go through the description and browse/download photos of the posts in the news feed.

<img src="/../master/screenshots/1.png" width="120">
<img src="/../master/screenshots/7.png" width="120">

###2.My Feed
The My Feed section allows you to create your own personalized news feed by following only the specific groups or societies you want to hear from.

<img src="/../master/screenshots/2.png" width="120">
<img src="/../master/screenshots/3.png" width="120">

###3.Video
[Junoon Photography Club's YouTube channel](https://www.youtube.com/channel/UCu445B5LTXzkNr5eft8wNHg) is the source of all entertainment going on in the college. No one wants to miss out on them, so this section gets you the latest uploads and also allows you to view them right there in the app. 

<img src="/../master/screenshots/4.png" width="120">


###4.Calendar
The Calendar helps you in tracking your attendance on a regular basis by recording your dates attended and missed (input by the user). It can also fetch your timetable from our server and give you advice about how many classes you need to attend to make up for short attendance or how many you can miss if you have more than enough attendance.

<img src="/../master/screenshots/5.png" width="120">
<img src="/../master/screenshots/6.png" width="120">

###5.Locations
Locations help you to get around the whole college by providing you with all hotspots that NSITians frequent. You can think of it as a Bible of all the places in NSIT and not only that, you can visit that location in a map and also check how far you are and how much time it will take you to reach there.

<img src="/../master/screenshots/8.png" width="120">
<img src="/../master/screenshots/9.png" width="120">


###6.CodeRadar 
CodeRadar is a Coding Contest Reminder that lets you keep track of all ongoing and upcoming contests on various online judges like Codechef, Topcoder, CodeForces, URIoj, HackerRank, etc. You can filter the online judges you want to see, set reminders and do much more. Happy Coding :)


<img src="/../master/screenshots/10.png" width="120">
<img src="/../master/screenshots/11.png" width="120">

###7.Calculator 
Calculator is a module to calculate your semester percentage. You just need to enter your class and the subjects along with their names, codes and credits will be displayed. Just enter your marks, and calculate your percentage. No need to tell anyone about it! ;)


<img src="/../master/screenshots/cal1.png" width="120">
<img src="/../master/screenshots/cal2.png" width="120">
<img src="/../master/screenshots/cal3.png" width="120">


##Building

To build, use the gradle wrapper scripts provided in the top level directory of the project. The following will
compile the application and run all unit tests:

GNU/Linux, OSX, UNIX:
```
./gradlew build
```

Windows:
```
./gradlew.bat build
```

##Other Repositories
####[iOS](https://github.com/Swapnil52/NSIT-Connect)
####[Windows](https://github.com/sgaggarwal2009/NSIT-Connect-Microsoft-App)



##Contribution
It's very easy to contribute to NSIT App v2. Just follow these steps:

1. Get the prerequisites ready. (learn Java and set up Android Studio)
2. Fork this project into your own repo.
3. Make your changes to that repo, and create a pull request.

That's all there is to be a contributor of NSIT App v2. We are looking forward to working together with lots of aspiring developers and to maintain this project by collaborating with the open community.

To know about the APIs used in the project and for other project-related documentation, please refer to our [wiki page](https://github.com/Swati4star/NSIT-App-v2/wiki).

##Project Maintainers
This project is founded and actively maintained by [Sidharth Patro](https://github.com/sdpatro/) and [Swati Garg](https://github.com/Swati4star/). For any sort of queries feel free to either mail at sidharth.patro@outlook.com or swati4star@gmail.com. We will certainly reply to you as soon as we can.
